/************************************************************************ 
 * RSTP library - Rapid Spanning Tree (802.1t, 802.1w) 
 * Copyright (C) 2001-2003 Optical Access 
 * Author: Alex Rozin 
 * 
 * Portions copyright (C) 2004 Andy Myers, who modified this code to
 * be C++ and wrapped it in BridgeSim
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; version 2.1
 *
 * This code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with RSTP library; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place -
 * Suite 330, Boston, MA 02111-1307, USA.
 **********************************************************************/

/* Port State Transition state machine : 17.24 */

#ifndef PORTSTATETRANSITIONS_H_INCLUDED
#define PORTSTATETRANSITIONS_H_INCLUDED

#include "StateMachine.h"

class Port;

class PortStateTransitions : public StateMachine
{
 public:
  PortStateTransitions(Port *owner);
  virtual ~PortStateTransitions() { }

  void EnterState();
  bool CheckCondition();
  char *GetStateName(int);

 protected:
  Port *owner;
  
  bool disableLearning();
  bool enableLearning();
  bool disableForwarding();
  bool enableForwarding();

};


#endif // PORTSTATETRANSITIONS_H_INCLUDED

