/************************************************************************ 
 * RSTP library - Rapid Spanning Tree (802.1t, 802.1w) 
 * Copyright (C) 2001-2003 Optical Access 
 * Author: Alex Rozin 
 * 
 * Portions copyright (C) 2004 Andy Myers, who modified this code to
 * be C++ and wrapped it in BridgeSim
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; version 2.1
 *
 * This code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with RSTP library; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place -
 * Suite 330, Boston, MA 02111-1307, USA.
 **********************************************************************/

/* Port Role Selection state machine : 17.22 */

#ifndef ROLESELECTION_H_INCLUDED
#define ROLESELECTION_H_INCLUDED

#include "StateMachine.h"
#include "Port.h"

class STPM;

class RoleSelection : public StateMachine
{
 public:
  RoleSelection(STPM *owner);
  virtual ~RoleSelection() { }
    
  void EnterState();
  bool CheckCondition();
  char *GetStateName(int);

 protected:
  STPM *owner;

  void STP_rolesel_update_stpm (struct stpm_t* t);

  bool _is_backup_port(Port *port, STPM *stpm);
  void setRoleSelected(char *reason, STPM *stpm, Port *port, PORT_ROLE_T newRole);
  void updtRoleDisableBridge(STPM *stpm);
  void clearReselectBridge(STPM *stpm);
  void updtRootPrio();
  void updtRolesBridge();
  bool setSelectedBridge();
  void STP_rolesel_update_stpm();
};

#endif // ROLESELECTION_H_INCLUDED

